VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4935
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6765
   LinkTopic       =   "Form1"
   ScaleHeight     =   4935
   ScaleWidth      =   6765
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdStep 
      Caption         =   "Step"
      Height          =   495
      Left            =   5520
      TabIndex        =   2
      Top             =   720
      Width           =   1095
   End
   Begin VB.CommandButton cmdReset 
      Caption         =   "Reset"
      Height          =   495
      Left            =   5520
      TabIndex        =   1
      Top             =   120
      Width           =   1095
   End
   Begin VB.PictureBox picCanvas 
      AutoRedraw      =   -1  'True
      Height          =   4695
      Left            =   120
      ScaleHeight     =   309
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   341
      TabIndex        =   0
      Top             =   120
      Width           =   5175
   End
   Begin VB.Label lblBestArea 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   5520
      TabIndex        =   6
      Top             =   2640
      Width           =   1095
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Best Area"
      Height          =   255
      Index           =   1
      Left            =   5520
      TabIndex        =   5
      Top             =   2400
      Width           =   1095
   End
   Begin VB.Label lblCurrentArea 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   5520
      TabIndex        =   4
      Top             =   1800
      Width           =   1095
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Current Area"
      Height          =   255
      Index           =   0
      Left            =   5520
      TabIndex        =   3
      Top             =   1560
      Width           =   1095
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function Polygon Lib "gdi32" (ByVal hdc As Long, lpPoint As POINTAPI, ByVal nCount As Long) As Long
Private Type POINTAPI
    X As Long
    Y As Long
End Type

' The polygon's points.
Private m_Points() As POINTAPI
Private m_NumPoints As Integer

' The points that have been used in test edges.
Private m_EdgeChecked() As Boolean

' The four caliper control points. They start:
'       m_ControlPoints(0)      Left edge       xmin
'       m_ControlPoints(1)      Bottom edge     ymax
'       m_ControlPoints(2)      Right edge      xmax
'       m_ControlPoints(3)      Top edge        ymin
Private m_ControlPoints(3) As Integer

' The line from this point to the next one forms
' one side of the rectangle.
Private m_CurrentControlPoint As Integer

' The area of the current bounding rectangle.
Private m_CurrentArea As Single
Private m_BestArea As Single
Private m_BestRectangle() As POINTAPI

' The number of bounding rectangles we have examined.
Private m_RectanglesExamined As Integer

' Find the slope of the edge from point i to point i+1.
Private Sub FindDxDy(ByRef dx As Single, ByRef dy As Single, ByVal i As Integer)
Dim i2 As Integer

    i2 = (i + 1) Mod m_NumPoints
    dx = m_Points(i2).X - m_Points(i).X
    dy = m_Points(i2).Y - m_Points(i).Y
End Sub

Private Sub AddPoint(ByVal X As Long, ByVal Y As Long)
    ReDim Preserve m_Points(0 To m_NumPoints)
    With m_Points(m_NumPoints)
        .X = X
        .Y = Y
    End With
    m_NumPoints = m_NumPoints + 1
End Sub

Private Sub DrawBoundingRectangle(ByVal color As OLE_COLOR, ByVal line_width As Integer, _
    ByVal px0 As Single, ByVal py0 As Single, ByVal dx0 As Single, ByVal dy0 As Single, _
    ByVal px1 As Single, ByVal py1 As Single, ByVal dx1 As Single, ByVal dy1 As Single, _
    ByVal px2 As Single, ByVal py2 As Single, ByVal dx2 As Single, ByVal dy2 As Single, _
    ByVal px3 As Single, ByVal py3 As Single, ByVal dx3 As Single, ByVal dy3 As Single)

    picCanvas.ForeColor = color
    picCanvas.DrawWidth = line_width

    ' Find the points of intersection.
    Dim pts(3) As POINTAPI
    FindIntersection px0, py0, px0 + dx0, py0 + dy0, px1, py1, px1 + dx1, py1 + dy1, pts(0).X, pts(0).Y
    FindIntersection px1, py1, px1 + dx1, py1 + dy1, px2, py2, px2 + dx2, py2 + dy2, pts(1).X, pts(1).Y
    FindIntersection px2, py2, px2 + dx2, py2 + dy2, px3, py3, px3 + dx3, py3 + dy3, pts(2).X, pts(2).Y
    FindIntersection px3, py3, px3 + dx3, py3 + dy3, px0, py0, px0 + dx0, py0 + dy0, pts(3).X, pts(3).Y

    ' Draw the bounding rectangle.
    Polygon picCanvas.hdc, pts(0), 4

    ' See if this is the best bounding rectangle do far.
    ' Get the area of the bounding rectangle.
    Dim vx0 As Single
    Dim vy0 As Single
    Dim len0 As Single
    Dim vx1 As Single
    Dim vy1 As Single
    Dim len1 As Single

    vx0 = pts(0).X - pts(1).X
    vy0 = pts(0).Y - pts(1).Y
    len0 = Sqr(vx0 * vx0 + vy0 * vy0)

    vx1 = pts(1).X - pts(2).X
    vy1 = pts(1).Y - pts(2).Y
    len1 = Sqr(vx1 * vx1 + vy1 * vy1)

    m_CurrentArea = len0 * len1
    If m_CurrentArea < m_BestArea Then
        m_BestArea = m_CurrentArea
        m_BestRectangle = pts
    End If

    lblCurrentArea.Caption = Format$(m_CurrentArea, "0.00")
    lblBestArea.Caption = Format$(m_BestArea, "0.00")
End Sub
' Find the point of intersection between two lines.
Private Function FindIntersection(ByVal X1 As Single, ByVal Y1 As Single, ByVal X2 As Single, ByVal Y2 As Single, ByVal A1 As Single, ByVal B1 As Single, ByVal A2 As Single, ByVal B2 As Single, ByRef intersect_x As Long, ByRef intersect_y As Long) As Boolean
Dim dx As Single
Dim dy As Single
Dim da As Single
Dim db As Single
Dim s As Single
Dim t As Single

    dx = X2 - X1
    dy = Y2 - Y1
    da = A2 - A1
    db = B2 - B1

    ' If the segments are parallel, return False.
    If Abs(da * dy - db * dx) < 0.001 Then
        FindIntersection = False
        Exit Function
    End If

    ' Find the point of intersection.
    s = (dx * (B1 - Y1) + dy * (X1 - A1)) / (da * dy - db * dx)
    t = (da * (Y1 - B1) + db * (A1 - X1)) / (db * dx - da * dy)
    intersect_x = X1 + t * dx
    intersect_y = Y1 + t * dy

    FindIntersection = True
End Function

' Get ready to start over.
Private Sub cmdReset_Click()
Dim minx As Integer
Dim maxx As Integer
Dim miny As Integer
Dim maxy As Integer
Dim minxi As Integer
Dim maxxi As Integer
Dim minyi As Integer
Dim maxyi As Integer
Dim i As Integer

    minx = m_Points(0).X
    maxx = minx
    miny = m_Points(0).Y
    maxy = miny
    minxi = 0
    maxxi = 0
    minyi = 0
    maxyi = 0

    For i = 1 To m_NumPoints - 1
        If minx > m_Points(i).X Then
            minx = m_Points(i).X
            minxi = i
        End If
        If maxx < m_Points(i).X Then
            maxx = m_Points(i).X
            maxxi = i
        End If
        If miny > m_Points(i).Y Then
            miny = m_Points(i).Y
            minyi = i
        End If
        If maxy < m_Points(i).Y Then
            maxy = m_Points(i).Y
            maxyi = i
        End If
    Next i

    m_ControlPoints(0) = minxi
    m_ControlPoints(1) = maxyi
    m_ControlPoints(2) = maxxi
    m_ControlPoints(3) = minyi
    m_CurrentControlPoint = -1

    ' We have not yet examined any bounding rectangles.
    m_RectanglesExamined = 0
    cmdStep.Enabled = True

    ' Reset the current and best bounding rectangle.
    m_CurrentArea = 100000
    m_BestArea = 100000

    ' So far we have not checked any edges.
    ReDim m_EdgeChecked(m_NumPoints - 1)
    For i = 0 To m_NumPoints - 1
        m_EdgeChecked(i) = False
    Next i

    ' Redraw.
    picCanvas_Paint
End Sub

' Check the next possible edge.
Private Sub cmdStep_Click()
Dim xminopp As Single
Dim xminadj As Single
Dim ymaxopp As Single
Dim ymaxadj As Single
Dim xmaxopp As Single
Dim xmaxadj As Single
Dim yminopp As Single
Dim yminadj As Single
Dim bestopp As Single
Dim bestadj As Single
Dim best_control_point As Integer

    ' Increment the current control point.
    ' This says we are done with using this edge.
    If m_CurrentControlPoint >= 0 Then
        m_ControlPoints(m_CurrentControlPoint) = (m_ControlPoints(m_CurrentControlPoint) + 1) Mod m_NumPoints
    End If

    ' Find the next point on an edge.
    Dim xmindx As Single, xmindy As Single
    Dim ymaxdx As Single, ymaxdy As Single
    Dim xmaxdx As Single, xmaxdy As Single
    Dim ymindx As Single, ymindy As Single
    FindDxDy xmindx, xmindy, m_ControlPoints(0)
    FindDxDy ymaxdx, ymaxdy, m_ControlPoints(1)
    FindDxDy xmaxdx, xmaxdy, m_ControlPoints(2)
    FindDxDy ymindx, ymindy, m_ControlPoints(3)

    ' Switch so we can look for the smallest opposite/adjacent ratio.
    xminopp = xmindx
    xminadj = xmindy
    ymaxopp = -ymaxdy
    ymaxadj = ymaxdx
    xmaxopp = -xmaxdx
    xmaxadj = -xmaxdy
    yminopp = ymindy
    yminadj = -ymindx

    ' Pick initial values that will make every point an improvement.
    bestopp = 1
    bestadj = 0
    best_control_point = -1

    If xminopp >= 0 And xminadj >= 0 Then
        If xminopp * bestadj < bestopp * xminadj Then
            bestopp = xminopp
            bestadj = xminadj
            best_control_point = 0
        End If
    End If
    If ymaxopp >= 0 And ymaxadj >= 0 Then
        If ymaxopp * bestadj < bestopp * ymaxadj Then
            bestopp = ymaxopp
            bestadj = ymaxadj
            best_control_point = 1
        End If
    End If
    If xmaxopp >= 0 And xmaxadj >= 0 Then
        If xmaxopp * bestadj < bestopp * xmaxadj Then
            bestopp = xmaxopp
            bestadj = xmaxadj
            best_control_point = 2
        End If
    End If
    If yminopp >= 0 And yminadj >= 0 Then
        If yminopp * bestadj < bestopp * yminadj Then
            bestopp = yminopp
            bestadj = yminadj
            best_control_point = 3
        End If
    End If

    ' Make sure we found a usable edge.
    If best_control_point < 0 Then Stop

    ' Use the new best control point.
    m_CurrentControlPoint = best_control_point

    ' Remember that we have checked this edge.
    m_EdgeChecked(m_ControlPoints(m_CurrentControlPoint)) = True

    ' See if we have checked all possible bounding rectangles.
    m_RectanglesExamined = m_RectanglesExamined + 1
    If m_RectanglesExamined >= m_NumPoints Then
        cmdStep.Enabled = False
    End If

    picCanvas_Paint
End Sub

Private Sub Form_Load()
    m_CurrentControlPoint = -1
    m_CurrentArea = 100000
    m_BestArea = 100000
    m_RectanglesExamined = 0

    ' Make some points.
    m_NumPoints = 0
    AddPoint 66, 196
    AddPoint 70, 210
    AddPoint 93, 222
    AddPoint 132, 232
    AddPoint 195, 237
    AddPoint 254, 172
    AddPoint 185, 51
    AddPoint 87, 92

    ' Reset to get ready.
    cmdReset_Click
End Sub


Private Sub picCanvas_Paint()
Dim i As Integer
Dim pt1 As Integer
Dim pt2 As Integer

    picCanvas.Cls

    ' See if we have started yet.
    If m_CurrentControlPoint = -1 Then
        ' Draw the initial bounding rectangle.
        DrawBoundingRectangle vbGreen, 3, _
            m_Points(m_ControlPoints(0)).X, m_Points(m_ControlPoints(0)).Y, 0, 1, _
            m_Points(m_ControlPoints(1)).X, m_Points(m_ControlPoints(1)).Y, 1, 0, _
            m_Points(m_ControlPoints(2)).X, m_Points(m_ControlPoints(2)).Y, 0, -1, _
            m_Points(m_ControlPoints(3)).X, m_Points(m_ControlPoints(3)).Y, -1, 0
    Else
        ' See which point has the current edge.
        Dim i1 As Integer
        Dim i2 As Integer
        Dim dx As Single
        Dim dy As Single
        Dim temp As Single

        i1 = m_ControlPoints(m_CurrentControlPoint)
        i2 = (i1 + 1) Mod m_NumPoints
        dx = m_Points(i2).X - m_Points(i1).X
        dy = m_Points(i2).Y - m_Points(i1).Y

        ' Make dx and dy work for the first line.
        Select Case m_CurrentControlPoint
            Case 0  ' Nothing to do.
            Case 1  ' dx = -dy, dy = dx
                temp = dx
                dx = -dy
                dy = temp
            Case 2  ' dx = -dx, dy = -dy
                dx = -dx
                dy = -dy
            Case 3  ' dx = dy, dy = -dx
                temp = dx
                dx = dy
                dy = -temp
        End Select

        ' Draw the bounding rectangle.
        DrawBoundingRectangle vbGreen, 3, _
            m_Points(m_ControlPoints(0)).X, m_Points(m_ControlPoints(0)).Y, dx, dy, _
            m_Points(m_ControlPoints(1)).X, m_Points(m_ControlPoints(1)).Y, dy, -dx, _
            m_Points(m_ControlPoints(2)).X, m_Points(m_ControlPoints(2)).Y, -dx, -dy, _
            m_Points(m_ControlPoints(3)).X, m_Points(m_ControlPoints(3)).Y, -dy, dx
    End If

    ' Draw the best bounding rectangle.
    picCanvas.ForeColor = RGB(0, 128, 0)
    picCanvas.DrawWidth = 1
    Polygon picCanvas.hdc, m_BestRectangle(0), 4

    ' Draw the polygon and its points.
    picCanvas.ForeColor = vbBlack
    picCanvas.DrawWidth = 5
    Polygon picCanvas.hdc, m_Points(0), m_NumPoints

    ' Mark the polygon points.
    picCanvas.ForeColor = vbRed
    picCanvas.Font.Bold = True
    For i = 0 To m_NumPoints - 1
        picCanvas.CurrentX = m_Points(i).X
        picCanvas.CurrentY = m_Points(i).Y
        picCanvas.Print Format$(i)
    Next i

    If True Then
        ' Draw the edges that have been checked.
        picCanvas.ForeColor = vbCyan
        picCanvas.DrawWidth = 3
        For i = 0 To m_NumPoints - 1
            If m_EdgeChecked(i) Then
                pt2 = (i + 1) Mod m_NumPoints
                picCanvas.Line (m_Points(i).X, m_Points(i).Y)-(m_Points(pt2).X, m_Points(pt2).Y)
            End If
        Next i

        ' Mark the control points.
        picCanvas.ForeColor = vbYellow
        For i = 0 To 3
            With m_Points(m_ControlPoints(i))
                picCanvas.CurrentX = .X + 6
                picCanvas.CurrentY = .Y
                picCanvas.Print Format$(i)
            End With
        Next i

        ' Mark the selected control point's edge.
        If m_CurrentControlPoint >= 0 Then
            pt1 = m_ControlPoints(m_CurrentControlPoint)
            pt2 = (pt1 + 1) Mod m_NumPoints
            picCanvas.ForeColor = vbRed
            picCanvas.DrawWidth = 3
            picCanvas.Line (m_Points(pt1).X, m_Points(pt1).Y)-(m_Points(pt2).X, m_Points(pt2).Y)
        End If
    End If
End Sub
